/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (C) Yeico S. A. de C. V.
 * xlsLib -- A multiplatform, C++ library for dynamic generation of Excel (TM) 
 * files.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  
 * $Source: /cvsroot/xlslib/xlslib/src/xlslib/blank.cpp,v $
 * $Revision: 1.1.1.1 $
 * $Author: darioglz $
 * $Date: 2004/08/27 16:31:54 $
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * File description:
 *
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#include "blank.h"

using namespace std;
using namespace xlslib_core;

CBlank::CBlank(unsigned16_t row,
               unsigned16_t col,
               xf_t* pxfval)
{

   SetRecordType(RECTYPE_BLANK);
   AddValue16(row);
   AddValue16(col);

   unsigned16_t xfindex;
   pxfval != NULL? 
      xfindex = pxfval->GetIndex()
      :xfindex = 0x000f;
   AddValue16(xfindex);   
   SetRecordLength(GetDataSize()-4);

}

CBlank::CBlank(blank_t& blankdef)
{
   SetRecordType(RECTYPE_LABEL);
   AddValue16(blankdef.GetRow());
   AddValue16(blankdef.GetCol());
   AddValue16(blankdef.GetXFIndex());

   SetRecordLength(GetDataSize()-4);
}

CBlank::~CBlank()
{
}

/*
*********************************
blank_t class implementation
*********************************
*/
blank_t::blank_t(unsigned16_t rowval, 
                 unsigned16_t colval, 
                 xf_t* pxfval)
{
   row = rowval;
   col = colval;

   if(pxfval != NULL)
      pxfval->MarkUsed();
   pxf = pxfval;
}

CUnit* blank_t::GetData() {
   CUnit* datablank = 
      (CUnit*)( new CBlank(row,col,pxf));
   return datablank; // NOTE: this pointer HAS to be deleted elsewhere.
}


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * $Log: blank.cpp,v $
 * Revision 1.1.1.1  2004/08/27 16:31:54  darioglz
 * Initial Import.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

