/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (C) Yeico S. A. de C. V.
 * xlsLib -- A multiplatform, C++ library for dynamic generation of Excel (TM) 
 * files.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  
 * $Source: /cvsroot/xlslib/xlslib/src/xlslib/number.cpp,v $
 * $Revision: 1.1.1.1 $
 * $Author: darioglz $
 * $Date: 2004/08/27 16:31:55 $
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 * File description:
 *
 *
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "number.h"

using namespace std;
using namespace xlslib_core;

CNumber::CNumber(unsigned16_t row,
                 unsigned16_t col,
                 double num,
                 xf_t* pxfval)
{

   SetRecordType(RECTYPE_NUMBER);
   AddValue16(row);
   AddValue16(col);

   unsigned16_t xfindex;
   pxfval != NULL? 
      xfindex = pxfval->GetIndex()
      :xfindex = 0x000f;
   AddValue16(xfindex);   
   
   void* pnumieee = (void*) &num;
   unsigned64_t numieee = *((unsigned64_t*)(pnumieee));
   AddValue64(numieee);

   SetRecordLength(GetDataSize()-4);

}

CNumber::CNumber(number_t& numdef)
{
   SetRecordType(RECTYPE_LABEL);
   AddValue16(numdef.GetRow());
   AddValue16(numdef.GetCol());
   AddValue16(numdef.GetXFIndex());

   double num = numdef.GetNumber();
   void* pnumieee = (void*) &num;
   unsigned64_t numieee = *((unsigned64_t*)(pnumieee));

   AddValue64(numieee);

   SetRecordLength(GetDataSize()-4);
}

CNumber::~CNumber()
{
}

/*
*********************************
number_t class implementation
*********************************
*/
number_t::number_t(unsigned16_t rowval, 
                   unsigned16_t colval, 
                   double numval, 
                   xf_t* pxfval)
{
   row = rowval;
   col = colval;
   number = numval;

   if(pxfval != NULL)
      pxfval->MarkUsed();
   pxf = pxfval;

}

CUnit* number_t::GetData() {
   CUnit* datanum = 
      (CUnit*)( new CNumber(row,col,number, pxf));
   return datanum; // NOTE: this pointer HAS to be deleted elsewhere.
}



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * $Log: number.cpp,v $
 * Revision 1.1.1.1  2004/08/27 16:31:55  darioglz
 * Initial Import.
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

